from ezdxf.tools.text import MTextEditor

# Fan Schedule Table START
def draw_fan_schedule_table(msp, x_offset=0, y_offset=0, number_of_hoods=2, table_data={}):
    
    fan_table_head_row_points = [
        (x_offset, y_offset),
        (x_offset + 240, y_offset),
        (x_offset + 240, y_offset - 11),
        (x_offset, y_offset - 11),
    ]
    
    fan_table_heading = str(MTextEditor("FAN SCHEDULE").font(name="Arial-Bold", bold=True))

    msp.add_mtext(
        fan_table_heading, 
        dxfattribs={
            'insert': (x_offset + 100, y_offset - 3), 
            'layer': 'TABLE',
            'char_height': 5,     
        }
    )
    
    msp.add_lwpolyline(fan_table_head_row_points, close=True, dxfattribs={'layer': 'TABLE'})
    
    fan_table_secondary_head_column_points1 = [
        (x_offset, y_offset - 18),
        
        (x_offset + 20, y_offset - 18),
        (x_offset + 20, y_offset - 11),
        
        (x_offset + 20 + 20, y_offset - 11),
        (x_offset + 20 + 20, y_offset - 18),
        
        (x_offset + 20 + 20 + 20, y_offset - 18),
        (x_offset + 20 + 20 + 20, y_offset - 11),
        
        (x_offset + 20 + 20 + 20 + 20, y_offset - 11),
        (x_offset + 20 + 20 + 20 + 20, y_offset - 18),
        
        (x_offset + 20 + 20 + 20 + 20 + 20, y_offset - 18),
        (x_offset + 20 + 20 + 20 + 20 + 20, y_offset - 11),
        
        (x_offset + 20 + 20 + 20 + 20 + 20 + 20, y_offset - 11),
        (x_offset + 20 + 20 + 20 + 20 + 20 + 20, y_offset - 18),
        
        (x_offset + 20 + 20 + 20 + 20 + 20 + 20 + 20, y_offset - 18),
        (x_offset + 20 + 20 + 20 + 20 + 20 + 20 + 20, y_offset - 11),
        
        (x_offset + 20 + 20 + 20 + 20 + 20 + 20 + 20 + 20, y_offset - 11),
        (x_offset + 20 + 20 + 20 + 20 + 20 + 20 + 20 + 20, y_offset - 18),
        
        (x_offset + 20 + 20 + 20 + 20 + 20 + 20 + 20 + 20 + 20, y_offset - 18),
        (x_offset + 20 + 20 + 20 + 20 + 20 + 20 + 20 + 20 + 20, y_offset - 11),
        
        (x_offset + 20 + 20 + 20 + 20 + 20 + 20 + 20 + 20 + 20 + 20, y_offset - 11),
        (x_offset + 20 + 20 + 20 + 20 + 20 + 20 + 20 + 20 + 20 + 20, y_offset - 18),
        
        (x_offset + 20 + 20 + 20 + 20 + 20 + 20 + 20 + 20 + 20 + 20 + 20, y_offset - 18),
        (x_offset + 20 + 20 + 20 + 20 + 20 + 20 + 20 + 20 + 20 + 20 + 20, y_offset - 11),
        
        (x_offset + 20 + 20 + 20 + 20 + 20 + 20 + 20 + 20 + 20 + 20 + 20 + 20, y_offset - 11),
        (x_offset + 20 + 20 + 20 + 20 + 20 + 20 + 20 + 20 + 20 + 20 + 20 + 20, y_offset - 18),
        
        (x_offset + 20 + 20 + 20 + 20 + 20 + 20 + 20 + 20 + 20 + 20 + 20 + 20, y_offset - 11),
        (x_offset, y_offset - 11),
    ]
    
    msp.add_mtext(
        "HOOD #",
        dxfattribs={
            'insert': (x_offset + 10, y_offset - 15),
            'layer': 'TABLE',
            'char_height': 1.75 ,
            'attachment_point': 5
        }
    )
    
    msp.add_mtext(
        "LABEL",
        dxfattribs={
            'insert': (x_offset + 30, y_offset - 15),
            'layer': 'TABLE',
            'char_height': 1.75 ,
            'attachment_point': 5
        }
    )
    
    msp.add_mtext(
        "MFG",
        dxfattribs={
            'insert': (x_offset + 50, y_offset - 15),
            'layer': 'TABLE',
            'char_height': 1.75 ,
            'attachment_point': 5
        }
    )
    
    msp.add_mtext(
        "MODEL",
        dxfattribs={
            'insert': (x_offset + 70, y_offset - 15),
            'layer': 'TABLE',
            'char_height': 1.75 ,
            'attachment_point': 5
        }
    )
    
    msp.add_mtext(
        "CFM",
        dxfattribs={
            'insert': (x_offset + 90, y_offset - 15),
            'layer': 'TABLE',
            'char_height': 1.75 ,
            'attachment_point': 5
        }
    )
    
    msp.add_mtext(
        "SP",
        dxfattribs={
            'insert': (x_offset + 110, y_offset - 15),
            'layer': 'TABLE',
            'char_height': 1.75 ,
            'attachment_point': 5
        }
    )
    
    msp.add_mtext(
        "HP",
        dxfattribs={
            'insert': (x_offset + 130, y_offset - 15),
            'layer': 'TABLE',
            'char_height': 1.75 ,
            'attachment_point': 5
        }
    )
    
    msp.add_mtext(
        "VOLTAGE",
        dxfattribs={
            'insert': (x_offset + 150, y_offset - 15),
            'layer': 'TABLE',
            'char_height': 1.75 ,
            'attachment_point': 5
        }
    )
    
    msp.add_mtext(
        "PHASE",
        dxfattribs={
            'insert': (x_offset + 170, y_offset - 15),
            'layer': 'TABLE',
            'char_height': 1.75 ,
            'attachment_point': 5
        }
    )
    
    msp.add_mtext(
        "RPM",
        dxfattribs={
            'insert': (x_offset + 190, y_offset - 15),
            'layer': 'TABLE',
            'char_height': 1.75 ,
            'attachment_point': 5
        }
    )
    
    msp.add_mtext(
        "AMPS",
        dxfattribs={
            'insert': (x_offset + 210, y_offset - 15),
            'layer': 'TABLE',
            'char_height': 1.75 ,
            'attachment_point': 5
        }
    )
    
    msp.add_mtext(
        "WGT (LBS)",
        dxfattribs={
            'insert': (x_offset + 230, y_offset - 15),
            'layer': 'TABLE',
            'char_height': 1.75 ,
            'attachment_point': 5
        }
    )
    
    for i in range(number_of_hoods):
        fan_table_secondary_head_column_points1_data = [
            (x_offset, y_offset - 18 - (i + 1) * 7),
            
            (x_offset + 20, y_offset - 18 - (i + 1) * 7),
            (x_offset + 20, y_offset - 11 - (i + 1) * 7),
            
            (x_offset + 20 + 20, y_offset - 11 - (i + 1) * 7),
            (x_offset + 20 + 20, y_offset - 18 - (i + 1) * 7),
            
            (x_offset + 20 + 20 + 20, y_offset - 18 - (i + 1) * 7),
            (x_offset + 20 + 20 + 20, y_offset - 11 - (i + 1) * 7),
            
            (x_offset + 20 + 20 + 20 + 20, y_offset - 11 - (i + 1) * 7),
            (x_offset + 20 + 20 + 20 + 20, y_offset - 18 - (i + 1) * 7),
            
            (x_offset + 20 + 20 + 20 + 20 + 20, y_offset - 18 - (i + 1) * 7),
            (x_offset + 20 + 20 + 20 + 20 + 20, y_offset - 11 - (i + 1) * 7),
            
            (x_offset + 20 + 20 + 20 + 20 + 20 + 20, y_offset - 11 - (i + 1) * 7),
            (x_offset + 20 + 20 + 20 + 20 + 20 + 20, y_offset - 18 - (i + 1) * 7),
            
            (x_offset + 20 + 20 + 20 + 20 + 20 + 20 + 20, y_offset - 18 - (i + 1) * 7),
            (x_offset + 20 + 20 + 20 + 20 + 20 + 20 + 20, y_offset - 11 - (i + 1) * 7),
            
            (x_offset + 20 + 20 + 20 + 20 + 20 + 20 + 20 + 20, y_offset - 11 - (i + 1) * 7),
            (x_offset + 20 + 20 + 20 + 20 + 20 + 20 + 20 + 20, y_offset - 18 - (i + 1) * 7),
            
            (x_offset + 20 + 20 + 20 + 20 + 20 + 20 + 20 + 20 + 20, y_offset - 18 - (i + 1) * 7),
            (x_offset + 20 + 20 + 20 + 20 + 20 + 20 + 20 + 20 + 20, y_offset - 11 - (i + 1) * 7),
            
            (x_offset + 20 + 20 + 20 + 20 + 20 + 20 + 20 + 20 + 20 + 20, y_offset - 11 - (i + 1) * 7),
            (x_offset + 20 + 20 + 20 + 20 + 20 + 20 + 20 + 20 + 20 + 20, y_offset - 18 - (i + 1) * 7),
            
            (x_offset + 20 + 20 + 20 + 20 + 20 + 20 + 20 + 20 + 20 + 20 + 20, y_offset - 18 - (i + 1) * 7),
            (x_offset + 20 + 20 + 20 + 20 + 20 + 20 + 20 + 20 + 20 + 20 + 20, y_offset - 11 - (i + 1) * 7),
            
            (x_offset + 20 + 20 + 20 + 20 + 20 + 20 + 20 + 20 + 20 + 20 + 20 + 20, y_offset - 11 - (i + 1) * 7),
            (x_offset + 20 + 20 + 20 + 20 + 20 + 20 + 20 + 20 + 20 + 20 + 20 + 20, y_offset - 18 - (i + 1) * 7),
            
            (x_offset + 20 + 20 + 20 + 20 + 20 + 20 + 20 + 20 + 20 + 20 + 20 + 20, y_offset - 11 - (i + 1) * 7),
            (x_offset, y_offset - 11 - (i + 1) * 7),
        ]
        
        msp.add_mtext(
            table_data[i]["HOOD_NO"],
            dxfattribs={
                'insert': (x_offset + 10, y_offset - 15 - (i + 1) * 7),
                'layer': 'TABLE',
                'char_height': 1.75 ,
                'attachment_point': 5
            }
        )
        
        msp.add_mtext(
            table_data[i]["LABEL"],
            dxfattribs={
                'insert': (x_offset + 30, y_offset - 15 - (i + 1) * 7),
                'layer': 'TABLE',
                'char_height': 1.75 ,
                'attachment_point': 5
            }
        )
        
        msp.add_mtext(
            table_data[i]["MFG"],
            dxfattribs={
                'insert': (x_offset + 50, y_offset - 15 - (i + 1) * 7),
                'layer': 'TABLE',
                'char_height': 1.75 ,
                'attachment_point': 5
            }
        )
        
        msp.add_mtext(
            table_data[i]["MODEL"],
            dxfattribs={
                'insert': (x_offset + 70, y_offset - 15 - (i + 1) * 7),
                'layer': 'TABLE',
                'char_height': 1.75 ,
                'attachment_point': 5
            }
        )
        
        msp.add_mtext(
            table_data[i]["CFM"],
            dxfattribs={
                'insert': (x_offset + 90, y_offset - 15 - (i + 1) * 7),
                'layer': 'TABLE',
                'char_height': 1.75 ,
                'attachment_point': 5
            }
        )
        
        msp.add_mtext(
            table_data[i]["SP"],
            dxfattribs={
                'insert': (x_offset + 110, y_offset - 15 - (i + 1) * 7),
                'layer': 'TABLE',
                'char_height': 1.75 ,
                'attachment_point': 5
            }
        )
        
        msp.add_mtext(
            table_data[i]["HP"],
            dxfattribs={
                'insert': (x_offset + 130, y_offset - 15 - (i + 1) * 7),
                'layer': 'TABLE',
                'char_height': 1.75 ,
                'attachment_point': 5
            }
        )
        
        msp.add_mtext(
            table_data[i]["VOLTAGE"],
            dxfattribs={
                'insert': (x_offset + 150, y_offset - 15 - (i + 1) * 7),
                'layer': 'TABLE',
                'char_height': 1.75 ,
                'attachment_point': 5
            }
        )
        
        msp.add_mtext(
            table_data[i]["PHASE"],
            dxfattribs={
                'insert': (x_offset + 170, y_offset - 15 - (i + 1) * 7),
                'layer': 'TABLE',
                'char_height': 1.75 ,
                'attachment_point': 5
            }
        )
        
        msp.add_mtext(
            table_data[i]["RPM"],
            dxfattribs={
                'insert': (x_offset + 190, y_offset - 15 - (i + 1) * 7),
                'layer': 'TABLE',
                'char_height': 1.75 ,
                'attachment_point': 5
            }
        )
        
        msp.add_mtext(
            table_data[i]["AMPS"],
            dxfattribs={
                'insert': (x_offset + 210, y_offset - 15 - (i + 1) * 7),
                'layer': 'TABLE',
                'char_height': 1.75 ,
                'attachment_point': 5
            }
        )
        
        msp.add_mtext(
            table_data[i]['WGT'],
            dxfattribs={
                'insert': (x_offset + 230, y_offset - 15 - (i + 1) * 7),
                'layer': 'TABLE',
                'char_height': 1.75 ,
                'attachment_point': 5
            }
        )
        
        if((i + 1) == number_of_hoods):
            last_line_points = [
                (x_offset, y_offset - 18 - (i + 1) * 7),
                (x_offset + 20 + 20 + 20 + 20 + 20 + 20 + 20 + 20 + 20 + 20 + 20 + 20, y_offset - 18 - (i + 1) * 7),
            ]
            msp.add_lwpolyline(last_line_points, close=True, dxfattribs={'layer': 'TABLE'})
    
        msp.add_lwpolyline(fan_table_secondary_head_column_points1_data, close=True, dxfattribs={'layer': 'TABLE'})
        
    msp.add_lwpolyline(fan_table_secondary_head_column_points1, close=True, dxfattribs={'layer': 'TABLE'})

# Fan Schedule Table END
